﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace FTT
{
    public static class cParameter
    {

        static string _xsdPath = string.Empty;
        static string _xsdFile = "parameter.xsd";

        static string _xmlPath = string.Empty;
        static string _xmlFile = "parameter.xml";
        static string _ComputerName = System.Environment.MachineName;

        static DataSet _DataSet;
        static string _Variablenname = string.Empty;


        public static DataSet DataSet
        {
            get
            {
                Load();
                return cParameter._DataSet;
            }

            set { cParameter._DataSet = value; }
        }


        public static void save()
        {
            _DataSet.WriteXml(_xmlPath);
        }

        public static void Load()
        {
            _xsdPath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Application.ExecutablePath), _xsdFile);

            _xmlPath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Application.ExecutablePath), _xmlFile);



            if (_DataSet == null)
            {
                _DataSet = new DataSet();
                _DataSet.ReadXmlSchema(_xsdPath);
                _DataSet.ReadXml(_xmlPath);
            }
        }



        public static void Save()
        {
            _xsdPath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Application.ExecutablePath), _xsdFile);

            _xmlPath = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Application.ExecutablePath), _xmlFile);



            if (_DataSet != null)
            {         
                
                _DataSet.WriteXml(_xmlPath);
            }
        }

        public static string getProgrammVariable(string Variablenname_,bool local_=false)
        {
            setVariablenname(Variablenname_, local_);
            try
            {
                DataRow[] objResultDataRow = DataSet.Tables[0].Select("variablenname = '" + _Variablenname + "'");
                return objResultDataRow[0]["wert"].ToString() ?? string.Empty;
            }
            catch (Exception)
            {
                return string.Empty;
            }
        }


        public static void SetProgrammVariable(string Variablenname_, string Wert_, bool local_ = false)
        {
            setVariablenname(Variablenname_, local_);


            try
            {
                DataRow[] objResultDataRows = DataSet.Tables[0].Select("variablenname = '" + _Variablenname + "'");
                if (objResultDataRows.Count()==0)
                {
                    DataRow dr = DataSet.Tables[0].NewRow();
                    dr["variablenname"] = _Variablenname;
                    dr["wert"] = Wert_;
                    DataSet.Tables[0].Rows.Add(dr);
                }
                else
                {
                    objResultDataRows[0]["wert"] = Wert_;
                }
               
                Save();
            }
            catch (Exception)
            {
               
            }
        }

        private static void setVariablenname(string Variablenname_, bool local_)
        {
            if (local_)
            {
                _Variablenname =Variablenname_+"_"+ _ComputerName;
            }

            else
            {
                _Variablenname = Variablenname_;
            }
        }


    }

}
