﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using BIB;

namespace FTT
{
    public partial class frmMain : Form
    {
        const string _ProgrammVariableFolderBasePath = "FolderBasePath";
        const string _ProgrammVariableFolderTargetPath = "FolderTargetPath";
        string _folderBasePath = cParameter.getProgrammVariable(_ProgrammVariableFolderBasePath, true);
        string _folderTargetPath = cParameter.getProgrammVariable(_ProgrammVariableFolderTargetPath, true);

        string  _AcroReaderExe="AcroRd32";

        IDataSet _IDataSet = new cDataSetXML();
        DataSet _DataSet = new DataSet();


        public frmMain()
        {
            InitializeComponent();
            InitForm();
        }

        private void InitForm()
        {
            if (_folderBasePath==string.Empty)
            {
                _folderBasePath= @"C:\Temp_PDF";
            }
            this.txtBasePath.Text = _folderBasePath;
        }
        private void frmMain_FormClosing(object sender, FormClosingEventArgs e)
        {
            cParameter.SetProgrammVariable(_ProgrammVariableFolderBasePath, _folderBasePath, true);
            cParameter.SetProgrammVariable(_ProgrammVariableFolderTargetPath, _folderTargetPath, true);
            KillAcroReader();
        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void cmdBrowseFolder_Click(object sender, EventArgs e)
        {
            ShowFolderBrowseDialog();
        }

        private void ShowFolderBrowseDialog()
        {
            FolderBrowserDialog objFolderBrowserDialog = new FolderBrowserDialog();
            _folderBasePath = this.txtBasePath.Text;
            if (System.IO.Directory.Exists(_folderBasePath))
            {
                objFolderBrowserDialog.SelectedPath = this.txtBasePath.Text; 
            }
            else
            {
                objFolderBrowserDialog.RootFolder = Environment.SpecialFolder.MyDocuments;
            }
            if (   objFolderBrowserDialog.ShowDialog()==System.Windows.Forms.DialogResult.OK)
            {
                _folderBasePath = objFolderBrowserDialog.SelectedPath;
                this.txtBasePath.Text = _folderBasePath;
            }
        }

        private void txtRefresh_Click(object sender, EventArgs e)
        {
            string[] objFiles = Directory.GetFiles(_folderBasePath,"*.*");
            foreach (string item in objFiles)
            {
                lstFiles.Items.Add(item);
            }
        }

        private void frmMain_Load(object sender, EventArgs e)
        {
            InitCombo();
        }

        private void InitCombo()
        {
            _DataSet = _IDataSet.Load();

            DataTable objDataTable = _DataSet.Tables["Objektart"];
            objDataTable.DefaultView.Sort = "Objektart";


            this.cboObjektart.DataSource = objDataTable;
            this.cboObjektart.ValueMember = "Objektart";
            this.cboObjektart.DisplayMember = "Objektart";
            this.cboObjektart.Sorted = true;


        }

        private void InitializeAdobe(string filePath)
        {
            try
            {
                this.axAcroPDF1.LoadFile(filePath);
                this.axAcroPDF1.src = filePath;
                this.axAcroPDF1.setShowToolbar(false);
                this.axAcroPDF1.setView("FitH");
                this.axAcroPDF1.setLayoutMode("SinglePage");
                this.axAcroPDF1.Show();
            }
            catch (Exception )
            {
                throw;
            }
        }

        private void lstFiles_Click(object sender, EventArgs e)
        {
            string strSelectedPath = string.Empty;
            if ( lstFiles.SelectedItem!=null)
            {
                 strSelectedPath = lstFiles.SelectedItem.ToString(); 
            }
            if (System.IO.File.Exists(strSelectedPath))
            {
                InitializeAdobe(strSelectedPath);
            }
        }

    

        

        private void OpenFile()
        {
            string strSelectedPath = lstFiles.SelectedItem.ToString();
            if (System.IO.File.Exists(strSelectedPath))
            {
                Process.Start(strSelectedPath);
            }
        }
        private void KillAcroReader()
        {


            try
            {
                var objProcesses = Process.GetProcesses().Where(pr => pr.ProcessName == _AcroReaderExe);

                foreach (Process ProcessItem in objProcesses)
                {
                    ProcessItem.Kill();
                }


                this.axAcroPDF1.Dispose();
                this.axAcroPDF1 = null;
            }
            catch (Exception ex)
            {

                MessageBox.Show(ex.Message);
            }

        }

        private void testToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //lstFiles.Items.Clear();



            frmParameter objParameter = new frmParameter();
            objParameter.Show();

        }

        private void testProgrammvariableToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string strResult = cParameter.getProgrammVariable("SourceBasePath");
            MessageBox.Show(strResult);
        }

        private void schowFrmTestToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmTest objTest = new frmTest();
            objTest.Show();
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }

        private void showFrmKontaktToolStripMenuItem_Click(object sender, EventArgs e)
        {
            frmKontakt objKontakt = new frmKontakt();
            objKontakt.Show();
        }

        private void testComputerToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string _xsdPath = string.Empty;
            string _xmlPath = string.Empty;

            //cParameter.SetProgrammVariable("xsdPath", _xsdPath,true);
            //cParameter.SetProgrammVariable("xmlPath", _xmlPath, true);

         _xsdPath=   cParameter.getProgrammVariable("xsdPath",  true);
         _xmlPath = cParameter.getProgrammVariable("xmlPath",  true);
           

        }


     
    }
}
